!!!!!!!COSMONET Cls calls!!!!!!!!!!!!!!!!

!Use CAMB
module CMB_Cls
use cosmonet
  use cmbtypes
  use CAMB, only : CAMB_GetResults, CAMB_GetAge, CAMBParams, CAMB_SetDefParams,Transfer_GetMatterPower, &
          AccuracyBoost,  Cl_scalar, Cl_tensor, Cl_lensed, outNone, w_lam, &
          CAMBParams_Set,Re_OpticalDepthAtZ, MT, CAMBdata, NonLinear_Pk,&
          CAMB_GetTransfers,CAMB_FreeCAMBdata,CAMB_InitCAMBdata, CAMB_TransfersToPowers, &
          initial_adiabatic,initial_vector,initial_iso_baryon,initial_iso_neutrino, initial_iso_neutrino_vel
          
  use settings
  use snovae
  implicit none
  logical :: Use_SN =.false. !Compute Supernovae likelihoods only when background changes
  logical :: compute_tensors = .false.
  logical :: CMB_lensing = .false.
  logical :: use_nonlinear = .false.

  Type ParamSetInfo  
    
    Type (CosmoTheory) :: Theory
    Type (CAMBdata)    :: Transfers
    Type (CMBParams)   :: LastParams
  end Type ParamSetInfo

  integer, parameter :: ScalClOrder(3) = (/1,3,2/), TensClOrder(4) = (/1,4,2,3/)
      !Mapping of CAMB CL array ordering to TT , TE, EE, BB  
  integer :: ncalls = 0
  type(CAMBParams)  CAMBP 
  logical :: w_is_w  = .true.

contains
  subroutine CMBToCAMB(CMB,P)
    use LambdaGeneral
    type(CMBParams) CMB
    type(CAMBParams)  P
    P = CAMBP
    P%omegab = CMB%omb
    P%omegan = CMB%omnu
    P%omegac = CMB%omc
    P%omegav = CMB%omv
    P%H0 = CMB%H0
    P%Reion%redshift= CMB%zre    
    if (w_is_w) then
     w_lam = CMB%w
    else
     P%InitialConditionVector(initial_iso_baryon) = CMB%w
     w_lam = -1
    end if
  end subroutine CMBToCAMB

 function RecomputeTransfers (A, B)
   logical RecomputeTransfers
   type(CMBParams) A, B

   RecomputeTransfers =  .not. (A%omb == B%omb .and. A%omc == B%omc .and. A%omv == B%omv .and. &
             A%omnu == B%omnu .and. A%zre == B%zre .and. A%omk == B%omk .and. A%w == B%w)
              
 end function RecomputeTransfers

subroutine COSMONET_GetCls(CMB, Info, Cls, error, time)
use cmbtypes
use cosmonet
 use ModelParams, only : ThreadNum
   type(CMBParams) CMB
   integer error
   Type(ParamSetInfo) Info
!   real Cls(lmax,1:num_Cls)
!   real Cl(lmax, 1:num_Cls)
real Cls(1500, 1:3)
real Cl(1500, 1:3)
   real MPK(1:172)
   real class(1:2)
   type(CAMBParams)  P
   logical NewTransfers, time
   integer zix
        integer n, almax,num_Cls, i
      integer, allocatable :: l_array(:)
	
        Type(NetStr)  netTT, netTE, netEE, WMAPnetLike, WMAP_1sigma_netlike, &
	MPK1netlike, MPK2netlike, netMPK, netclass
    error = 0
    Newtransfers = .false.

 

!!!!n=number of computed l values i.e. 50 for lmax = 1500
n = 50
almax = 1500
num_Cls = 3

allocate(l_array(1:n))

 l_array(      	    1 )=           2
 l_array(           2 )=           3
 l_array(           3 )=           4
 l_array(           4 )=           5
 l_array(           5 )=           6
 l_array(           6 )=           7
 l_array(           7 )=           8
 l_array(           8 )=           9
 l_array(           9 )=          10
 l_array(          10 )=          12
 l_array(          11 )=          15
 l_array(          12 )=          20
 l_array(          13 )=          30
 l_array(          14 )=          40
 l_array(          15 )=          50
 l_array(          16 )=          60
 l_array(          17 )=          70
 l_array(          18 )=          80
 l_array(          19 )=          90
 l_array(          20 )=         110
 l_array(          21 )=         130
 l_array(          22 )=         150
 l_array(          23 )=         175
 l_array(          24 )=         200
 l_array(          25 )=         250
 l_array(          26 )=         300
 l_array(          27 )=         350
 l_array(          28 )=         400
 l_array(          29 )=         450
 l_array(          30 )=         500
 l_array(          31 )=         550
 l_array(          32 )=         600
 l_array(          33 )=         650
 l_array(          34 )=         700
 l_array(          35 )=         750
 l_array(          36 )=         800
 l_array(          37 )=         850
 l_array(          38 )=         900
 l_array(          39 )=         950
 l_array(          40 )=        1000
 l_array(          41 )=        1050
 l_array(          42 )=        1100
 l_array(          43 )=        1150
 l_array(          44 )=        1200
 l_array(          45 )=        1250
 l_array(          46 )=        1300
 l_array(          47 )=        1350
 l_array(          48 )=        1400
 l_array(          49 )=        1450
 l_array(          50 )=        1500
                                                                                                                              
                                                                                                                              
                                                                                                                              
!if (user_cosmonet == .false.) then
	call CAMB_InitCAMBdata(Info%Transfers)
	call CMBToCAMB(CMB,P)
!end if        


if (Use_LSS) then
Info%Transfers%MTrans%num_q_trans = 153
allocate(Info%Transfers%MTrans%q_trans(153))
allocate(Info%Transfers%MTrans%TransferData(7,153,1))                                                                                                                  
 Info%Transfers%MTrans%TransferData(7,:,1) = 0d0
 
end if

if (Feedback > 1) write (*,*) 'Calling CAMBNET'
                                                                                                                              
if (time) then
!!!initialise cambnet!!!!
call init_cambnet(netTT, netTE, netEE, netMPK, weightsTT, weightsTE, weightsEE, weightsMPK, labelsTT, labelsTE,labelsEE,labelsMPK, time)
!!!initialise like_cambnet!!!!
call init_cambnetWMAPLike(time)
!call init_cambnetWMAP1sigmaLike(time)
call init_cambnetMPK1Like(time)
call init_cambnetMPK2Like(time)
call init_classnet(time)
end if


!!!CAMBNET TT!!!!
call regress_cambnet(P, weightsTT, netTT, Cl, lmax, 1, l_array)
!!!CAMBNET TE!!!!
call regress_cambnet(P, weightsTE, netTE, Cl, lmax, 2, l_array)
!!!CAMB EE!!!!
call regress_cambnet(P, weightsEE, netEE, Cl, lmax, 3, l_array)


!!!!CLASS!!!!!!
!call regress_classnet(P, classweights, netclass, class)

!write(*,*) "class", class



!if ( exp(-1*class(2)) / (exp(-1*class(1)) + exp(-1*class(2)) )  < 0.01 ) then
!	write(*,*) "class accepted"
	class_reject = .false.
!else
!	write(*,*) "class rejected"
!        class_reject = .true.
!end if

!if ( CMB%omk .eq. 0d0 ) then
! class_reject = .false.
!end if

                                                                                                                         
if (Feedback > 1) write (*,*) 'CAMBNET done'
                                                                                                                              
!!!!!now need to interpolate between flat l values from CAMBNET!!!!
                                                                                                                              
if (Feedback > 2) write(*,*) 'Interpolating Cls'
call InterpCls(l_array, Cl, Cls, n, almax, num_Cls)

!!!!!Fill up all the Info arrays etc.!!!!!!!

Info%Theory%Age = CAMB_GetAge(P)
                                                                                                                              
!!!!Now all the transfer stuff!!!
if (Use_LSS) then
call regress_cambnetMPK(P, weightsMPK, netMPK, MPK)

Info%Transfers%MTrans%TransferData(7,:,1) = MPK(:) 


!!!!Now all the transfer stuff!!!   
 

Info%Transfers%MTrans%q_trans(           1 )=  5.306234015733935E-005
 Info%Transfers%MTrans%q_trans(           2 )=  5.864294871571474E-005
 Info%Transfers%MTrans%q_trans(           3 )=  6.481049786088988E-005
 Info%Transfers%MTrans%q_trans(           4 )=  7.162665860960260E-005
 Info%Transfers%MTrans%q_trans(           5 )=  7.915966853033751E-005
 Info%Transfers%MTrans%q_trans(           6 )=  8.748497930355370E-005
 Info%Transfers%MTrans%q_trans(           7 )=  9.668590064393356E-005
 Info%Transfers%MTrans%q_trans(           8 )=  1.068544006557204E-004
 Info%Transfers%MTrans%q_trans(           9 )=  1.180924009531736E-004
 Info%Transfers%MTrans%q_trans(          10 )=  1.305123005295172E-004
 Info%Transfers%MTrans%q_trans(          11 )=  1.442383945686743E-004
 Info%Transfers%MTrans%q_trans(          12 )=  1.594080968061462E-004
 Info%Transfers%MTrans%q_trans(          13 )=  1.761731982696801E-004
 Info%Transfers%MTrans%q_trans(          14 )=  1.947014970937744E-004
 Info%Transfers%MTrans%q_trans(          15 )=  2.151783992303535E-004
 Info%Transfers%MTrans%q_trans(          16 )=  2.378088975092396E-004
 Info%Transfers%MTrans%q_trans(          17 )=  2.628194924909621E-004
 Info%Transfers%MTrans%q_trans(          18 )=  2.904605062212795E-004
 Info%Transfers%MTrans%q_trans(          19 )=  3.210084105376154E-004
 Info%Transfers%MTrans%q_trans(          20 )=  3.547692031133920E-004
 Info%Transfers%MTrans%q_trans(          21 )=  3.920806047972292E-004
 Info%Transfers%MTrans%q_trans(          22 )=  4.333161050453782E-004
 Info%Transfers%MTrans%q_trans(          23 )=  4.788883088622242E-004
 Info%Transfers%MTrans%q_trans(          24 )=  5.292533896863461E-004
 Info%Transfers%MTrans%q_trans(          25 )=  5.849155131727457E-004
 Info%Transfers%MTrans%q_trans(          26 )=  6.464312900789082E-004
 Info%Transfers%MTrans%q_trans(          27 )=  7.144173141568899E-004
 Info%Transfers%MTrans%q_trans(          28 )=  7.895533926784992E-004
 Info%Transfers%MTrans%q_trans(          29 )=  8.725916268303990E-004
 Info%Transfers%MTrans%q_trans(          30 )=  9.643622906878591E-004
 Info%Transfers%MTrans%q_trans(          31 )=  1.065785996615887E-003
 Info%Transfers%MTrans%q_trans(          32 )=  1.177874975837767E-003
 Info%Transfers%MTrans%q_trans(          33 )=  1.301754033192992E-003
 Info%Transfers%MTrans%q_trans(          34 )=  1.438659965060651E-003
 Info%Transfers%MTrans%q_trans(          35 )=  1.589964958839118E-003
 Info%Transfers%MTrans%q_trans(          36 )=  1.757182995788753E-003
 Info%Transfers%MTrans%q_trans(          37 )=  1.941988011822104E-003
 Info%Transfers%MTrans%q_trans(          38 )=  2.146227983757854E-003
 Info%Transfers%MTrans%q_trans(          39 )=  2.371948910877109E-003
 Info%Transfers%MTrans%q_trans(          40 )=  2.621409017592669E-003
 Info%Transfers%MTrans%q_trans(          41 )=  2.897106111049652E-003
 Info%Transfers%MTrans%q_trans(          42 )=  3.201796906068921E-003
 Info%Transfers%MTrans%q_trans(          43 )=  3.538531949743629E-003
 Info%Transfers%MTrans%q_trans(          44 )=  3.910684026777744E-003
 Info%Transfers%MTrans%q_trans(          45 )=  4.321972839534283E-003
 Info%Transfers%MTrans%q_trans(          46 )=  4.776520188897848E-003
 Info%Transfers%MTrans%q_trans(          47 )=  5.278870929032564E-003
 Info%Transfers%MTrans%q_trans(          48 )=  5.834054201841354E-003
 Info%Transfers%MTrans%q_trans(          49 )=  6.447625812143087E-003
 Info%Transfers%MTrans%q_trans(          50 )=  7.125730160623789E-003
 Info%Transfers%MTrans%q_trans(          51 )=  7.875151000916958E-003
 Info%Transfers%MTrans%q_trans(          52 )=  8.703383617103100E-003
 Info%Transfers%MTrans%q_trans(          53 )=  9.618725627660751E-003
 Info%Transfers%MTrans%q_trans(          54 )=  1.063034031540155E-002
 Info%Transfers%MTrans%q_trans(          55 )=  1.174833998084068E-002
 Info%Transfers%MTrans%q_trans(          56 )=  1.298392005264759E-002
 Info%Transfers%MTrans%q_trans(          57 )=  1.434945967048407E-002
 Info%Transfers%MTrans%q_trans(          58 )=  1.585859991610050E-002
 Info%Transfers%MTrans%q_trans(          59 )=  1.752646081149578E-002
 Info%Transfers%MTrans%q_trans(          60 )=  1.936974003911018E-002
 Info%Transfers%MTrans%q_trans(          61 )=  2.140687033534050E-002
 Info%Transfers%MTrans%q_trans(          62 )=  2.365826070308685E-002
 Info%Transfers%MTrans%q_trans(          63 )=  2.614641003310680E-002
 Info%Transfers%MTrans%q_trans(          64 )=  2.889625914394855E-002
 Info%Transfers%MTrans%q_trans(          65 )=  3.202379867434502E-002
 Info%Transfers%MTrans%q_trans(          66 )=  3.515134006738663E-002
 Info%Transfers%MTrans%q_trans(          67 )=  3.827888891100883E-002
 Info%Transfers%MTrans%q_trans(          68 )=  4.140643030405045E-002
 Info%Transfers%MTrans%q_trans(          69 )=  4.453397914767265E-002
 Info%Transfers%MTrans%q_trans(          70 )=  4.766152054071426E-002
 Info%Transfers%MTrans%q_trans(          71 )=  5.078906938433647E-002
 Info%Transfers%MTrans%q_trans(          72 )=  5.391661077737808E-002
 Info%Transfers%MTrans%q_trans(          73 )=  5.704415962100029E-002
 Info%Transfers%MTrans%q_trans(          74 )=  6.017170101404190E-002
 Info%Transfers%MTrans%q_trans(          75 )=  6.329923868179321E-002
 Info%Transfers%MTrans%q_trans(          76 )=  6.642679870128632E-002
 Info%Transfers%MTrans%q_trans(          77 )=  7.216060906648636E-002
 Info%Transfers%MTrans%q_trans(          78 )=  7.789441943168640E-002
 Info%Transfers%MTrans%q_trans(          79 )=  8.362828940153122E-002
 Info%Transfers%MTrans%q_trans(          80 )=  8.936209976673126E-002
 Info%Transfers%MTrans%q_trans(          81 )=  9.509591013193130E-002
 Info%Transfers%MTrans%q_trans(          82 )=  0.100829802453518
 Info%Transfers%MTrans%q_trans(          83 )=  0.106563597917557
 Info%Transfers%MTrans%q_trans(          84 )=  0.112297400832176
 Info%Transfers%MTrans%q_trans(          85 )=  0.118031300604343
 Info%Transfers%MTrans%q_trans(          86 )=  0.123765103518963
 Info%Transfers%MTrans%q_trans(          87 )=  0.129498898983002
 Info%Transfers%MTrans%q_trans(          88 )=  0.135232806205750
 Info%Transfers%MTrans%q_trans(          89 )=  0.140966594219208
 Info%Transfers%MTrans%q_trans(          90 )=  0.146700397133827
 Info%Transfers%MTrans%q_trans(          91 )=  0.152434304356575
 Info%Transfers%MTrans%q_trans(          92 )=  0.158168107271194
 Info%Transfers%MTrans%q_trans(          93 )=  0.163901895284653
 Info%Transfers%MTrans%q_trans(          94 )=  0.169635802507401
 Info%Transfers%MTrans%q_trans(          95 )=  0.175369605422020
 Info%Transfers%MTrans%q_trans(          96 )=  0.181103393435478
 Info%Transfers%MTrans%q_trans(          97 )=  0.186837300658226
 Info%Transfers%MTrans%q_trans(          98 )=  0.192571103572845
 Info%Transfers%MTrans%q_trans(          99 )=  0.198304906487465
 Info%Transfers%MTrans%q_trans(         100 )=  0.204038694500923
 Info%Transfers%MTrans%q_trans(         101 )=  0.209772601723671
 Info%Transfers%MTrans%q_trans(         102 )=  0.215506404638290
 Info%Transfers%MTrans%q_trans(         103 )=  0.221240192651749
 Info%Transfers%MTrans%q_trans(         104 )=  0.226974099874496
 Info%Transfers%MTrans%q_trans(         105 )=  0.232707902789116
 Info%Transfers%MTrans%q_trans(         106 )=  0.238441705703735
 Info%Transfers%MTrans%q_trans(         107 )=  0.244175493717194
 Info%Transfers%MTrans%q_trans(         108 )=  0.249909400939941
 Info%Transfers%MTrans%q_trans(         109 )=  0.255643188953400
 Info%Transfers%MTrans%q_trans(         110 )=  0.261377006769180
 Info%Transfers%MTrans%q_trans(         111 )=  0.267110794782639
 Info%Transfers%MTrans%q_trans(         112 )=  0.272844702005386
 Info%Transfers%MTrans%q_trans(         113 )=  0.278578490018845
 Info%Transfers%MTrans%q_trans(         114 )=  0.284312307834625
 Info%Transfers%MTrans%q_trans(         115 )=  0.290046185255051
 Info%Transfers%MTrans%q_trans(         116 )=  0.295780003070831
 Info%Transfers%MTrans%q_trans(         117 )=  0.301513791084290
 Info%Transfers%MTrans%q_trans(         118 )=  0.307247608900070
 Info%Transfers%MTrans%q_trans(         119 )=  0.312981486320496
 Info%Transfers%MTrans%q_trans(         120 )=  0.318715304136276
 Info%Transfers%MTrans%q_trans(         121 )=  0.324449092149734
 Info%Transfers%MTrans%q_trans(         122 )=  0.330182999372482
 Info%Transfers%MTrans%q_trans(         123 )=  0.335916787385941
 Info%Transfers%MTrans%q_trans(         124 )=  0.341650605201721
 Info%Transfers%MTrans%q_trans(         125 )=  0.347384512424469
 Info%Transfers%MTrans%q_trans(         126 )=  0.353118300437927
 Info%Transfers%MTrans%q_trans(         127 )=  0.358852088451385
 Info%Transfers%MTrans%q_trans(         128 )=  0.364585995674133
 Info%Transfers%MTrans%q_trans(         129 )=  0.370319813489914
 Info%Transfers%MTrans%q_trans(         130 )=  0.376053601503372
 Info%Transfers%MTrans%q_trans(         131 )=  0.381787508726120
 Info%Transfers%MTrans%q_trans(         132 )=  0.387521296739578
 Info%Transfers%MTrans%q_trans(         133 )=  0.393255114555359
 Info%Transfers%MTrans%q_trans(         134 )=  0.398988991975784
 Info%Transfers%MTrans%q_trans(         135 )=  0.404722809791565
 Info%Transfers%MTrans%q_trans(         136 )=  0.410456687211990
 Info%Transfers%MTrans%q_trans(         137 )=  0.416190505027771
 Info%Transfers%MTrans%q_trans(         138 )=  0.421924293041229
 Info%Transfers%MTrans%q_trans(         139 )=  0.427658200263977
 Info%Transfers%MTrans%q_trans(         140 )=  0.433391988277435
 Info%Transfers%MTrans%q_trans(         141 )=  0.439125806093216
 Info%Transfers%MTrans%q_trans(         142 )=  0.444859713315964
 Info%Transfers%MTrans%q_trans(         143 )=  0.450593411922455
 Info%Transfers%MTrans%q_trans(         144 )=  0.456327289342880
 Info%Transfers%MTrans%q_trans(         145 )=  0.462061107158661
 Info%Transfers%MTrans%q_trans(         146 )=  0.467794895172119
 Info%Transfers%MTrans%q_trans(         147 )=  0.473528802394867
 Info%Transfers%MTrans%q_trans(         148 )=  0.479262590408325
 Info%Transfers%MTrans%q_trans(         149 )=  0.585372686386108
 Info%Transfers%MTrans%q_trans(         150 )=  0.714975774288177
 Info%Transfers%MTrans%q_trans(         151 )=  0.873273670673370
 Info%Transfers%MTrans%q_trans(         152 )=   1.06661903858185
 Info%Transfers%MTrans%q_trans(         153 )=   1.30277097225189


 do i=1, Info%Transfers%MTrans%num_q_trans 
	Info%Transfers%MTrans%TransferData(1,i,1) = Info%Transfers%MTrans%q_trans(i)/(P%H0/100)
 end do



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
!!!!!!can we do this here:? from Transfer_Get_sigma8 in modules.f90 
!!!!!!Transfer_Get_sigma8(MT,8._dl)    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

            !Info%Theory%sigma_8 = Info%Transfers%MTrans%sigma_8(matter_power_lnzsteps,1)
     !       if (num_matter_power /= 0) then
                do zix = 1,matter_power_lnzsteps
                 call Transfer_GetMatterPower(Info%Transfers%MTrans,& 
                   Info%Theory%matter_power(:,zix),matter_power_lnzsteps-zix+1,&
                    1,matter_power_minkh, matter_power_dlnkh,num_matter_power) 
                 end do             
            !do i=1, 153
		!write(*,*) i, Info%Theory%matter_power(i,1)
	    !end do
		! end if
         !else
            Info%Theory%sigma_8 = 0
    end if  
                                                                                                    
end subroutine COSMONET_GetCls


 subroutine GetCls(CMB,Info, Cls, error)
   use ModelParams, only : ThreadNum
   type(CMBParams) CMB
   integer error
   Type(ParamSetInfo) Info
   real Cls(lmax,1:num_Cls)
   type(CAMBParams)  P
   logical NewTransfers
   integer zix
    error = 0
    Newtransfers = .false.
  
    if (RecomputeTransfers(CMB, Info%LastParams))  then
     !Slow parameters have changed
         call CAMB_InitCAMBdata(Info%Transfers)
         call CMBToCAMB(CMB, P) 
      
         if (Feedback > 1) write (*,*) 'Calling CAMB'
         Threadnum =num_threads
  
         call CAMB_GetTransfers(P, Info%Transfers, error)
         NewTransfers = .true.
         Info%LastParams = CMB
         if (Use_SN) then
            Info%Theory%SN_Loglike = SN_LnLike(CMB)
         else
            Info%Theory%SN_Loglike = 0     
         end if  
         ncalls=ncalls+1
         if (mod(ncalls,100)==0 .and. logfile_unit/=0) write (logfile_unit,*) 'CAMB called ',ncalls, ' times'
    
         if (Feedback > 1) write (*,*) 'CAMB done'

    end if 
    
!    if ((error==0) .and. (Newtransfers .or. any(CMB%InitPower /= Info%LastParams%InitPower))) then
       !Use the initial power spectra to get the Cls and matter power spectrum
     if (error == 0) then
      !Always get everything again. Slight waste of time in general, but allows complete mixing of fast
      !parameters, and works with lensing

         call SetCAMBInitPower(Info%Transfers%Params,CMB,1)       

         call CAMB_TransfersToPowers(Info%Transfers)
            !this sets slow CAMB params correctly from value stored in Transfers
           
         call SetTheoryFromCAMB(Info%Theory)
    
         if (any(Info%Theory%cl(:,1) < 0 )) then
            error = 1
            !Kill initial power spectra that go negative
            return
         end if
   
         if (Use_LSS) then
            Info%Theory%sigma_8 = Info%Transfers%MTrans%sigma_8(matter_power_lnzsteps,1)
            if (num_matter_power /= 0) then
                do zix = 1,matter_power_lnzsteps
                 call Transfer_GetMatterPower(Info%Transfers%MTrans,& 
                   Info%Theory%matter_power(:,zix),matter_power_lnzsteps-zix+1,&
                    1,matter_power_minkh, matter_power_dlnkh,num_matter_power) 
                 end do             
             end if
         else
            Info%Theory%sigma_8 = 0
         end if

     end if
     if (error /= 0) return

     call ClsFromTheoryData(Info%Theory, CMB, Cls)
     
 end subroutine GetCls

 subroutine SetTheoryFromCAMB(Theory)
   Type(CosmoTheory) Theory
   real, parameter :: cons =  2.726e6**2*2*pi
   real nm
   integer l

   !The reason we store tensors separately is that can then importance sample re-computing scalars only,
   !using the stored tensor C_l

    do l = 2, lmax

       nm = cons/(l*(l+1))
       if (CMB_Lensing) then
            Theory%cl(l,1:num_clsS) =  nm*Cl_lensed(l,1, TensClOrder(1:num_clsS))
         else 
            Theory%cl(l,1:num_clsS) =  nm*Cl_scalar(l,1, scalClOrder(1:num_clsS))
       end if         
   
       if (compute_tensors .and. l<=lmax_tensor) then
            Theory%cl_tensor(l,1:num_cls) =  nm*Cl_tensor(l,1, TensClOrder(1:num_cls))
       end if
    end do 
    
    if (num_cls>num_clsS) Theory%cl(:,num_clsS+1:num_cls) = 0 


 end subroutine SetTheoryFromCAMB

 subroutine GetClsInfo(CMB, Theory, error, DoCls, DoPk)
   use ModelParams, only : ThreadNum
   type(CMBParams) CMB
   Type(CosmoTheory) Theory
   integer error
   logical, intent(in) :: DoCls, DoPk
   type(CAMBParams)  P
   logical MatterOnly
   integer zix
   error = 0
   Threadnum =num_threads
   call CMBToCAMB(CMB, P)
   P%OnlyTransfers = .false.
   call SetCAMBInitPower(P,CMB,1)   
    
   MatterOnly = .false.
   if (DoPk) then
      P%WantTransfer = .true.
      if (.not. DoCls) then
         MatterOnly = .true.         
         P%WantScalars = .false.
         P%WantTensors = .false.
      end if
   end if
   if (DoCls) then
      !Assume we just want Cls to higher l
      P%WantScalars = .true.
      !P%WantTensors = .false.
      !compute_tensors = .false.
      P%WantTensors = compute_tensors 
       
       if (.not. DoPk) then
        P%WantTransfer = .false.
       end if
   end if
   
   call CAMB_GetResults(P)
   error = 0 !using error optional parameter gives seg faults on SGI
   if (error==0) then
       
      if (DoCls) then
  
       Theory%cl_tensor(2:lmax_tensor,1:num_cls) = 0
       call SetTheoryFromCAMB(Theory)
      end if
  
      if (DoPk) then 
         Theory%sigma_8 = MT%sigma_8(matter_power_lnzsteps,1)
         if (num_matter_power /= 0) then
           do zix = 1,matter_power_lnzsteps
                 call Transfer_GetMatterPower(MT,& 
             Theory%matter_power(:,zix),matter_power_lnzsteps-zix+1,1,matter_power_minkh,&
                        matter_power_dlnkh,num_matter_power) 
           end do
         
         end if    
      end if
      Theory%Age = CAMB_GetAge(P)

   end if
 end subroutine GetClsInfo


 subroutine InitCAMB(CMB,error)
   type(CMBParams), intent(in) :: CMB
   type(CAMBParams)  P
   integer error

   call CMBToCAMB(CMB, P)
   call CAMBParams_Set(P,error)

 end subroutine InitCAMB

 function GetOpticalDepth(CMB)
   type(CMBParams) CMB
   real GetOpticalDepth
   integer error

   call InitCAMB(CMB,error)
   if (error/= 0) then
      GetOpticalDepth = -1 
   else
      GetOpticalDepth = Re_OpticalDepthAtZ(CMB%zre*1.d0)
   end if
 end  function GetOpticalDepth
 
 function GetAge(CMB, Info)
   !Return <0 if error
   real GetAge
   type(CMBParams) CMB
   Type(ParamSetInfo) Info
   type(CAMBParams)  P
   call CMBToCAMB(CMB, P)
 
   Info%Theory%Age = CAMB_GetAge(P)
 
   GetAge = Info%Theory%Age
 end function GetAge

 subroutine InitCAMBParams(P)
   use lensing
   use ModelParams
   use Lya
   type(CAMBParams)  P 
   integer zix

        Threadnum =num_threads
        w_lam = -1
        call CAMB_SetDefParams(P)
 
        P%OutputNormalization = outNone
      
        P%WantScalars = .true.
        P%WantTensors = compute_tensors
        P%WantTransfer = Use_LSS

        P%Max_l=lmax
        P%Max_eta_k=lmax*2
        P%Max_l_tensor=lmax_tensor
        P%Max_eta_k_tensor=lmax_tensor*5./2
 
        P%Transfer%k_per_logint=0
 
        if (use_nonlinear) then
         P%NonLinear = NonLinear_Pk
         P%Transfer%kmax = 1.2
        else
         P%Transfer%kmax = 0.8
        end if
        if (Use_Lya) P%Transfer%kmax = lya_kmax
        P%Transfer%num_redshifts = matter_power_lnzsteps
        
        if (AccuracyLevel > 1) then
          if (USE_LSS) then
            P%Transfer%high_precision=.true.
            P%Transfer%kmax=P%Transfer%kmax + 0.2
           end if
          AccuracyBoost = AccuracyLevel
          lAccuracyBoost = AccuracyLevel
          lSampleBoost = AccuracyLevel
          P%AccurateReionization = .true.
        end if
                
        if (max_transfer_redshifts < matter_power_lnzsteps) then
          stop 'Need to manually set max_transfer_redshifts larger in CAMB''s modules.f90'
        end if
        if (matter_power_lnzsteps==1) then
          P%Transfer%redshifts(1) = 0
        else
         do zix=1, matter_power_lnzsteps
           !Linear spacing in log(z+1)
           
          P%Transfer%redshifts(zix) = exp( log(matter_power_maxz+1) * &
                real(matter_power_lnzsteps-zix)/(max(2,matter_power_lnzsteps)-1) )-1
               !put in max(2,) to stop compilers complaining of div by zero
         end do
        end if   
        
        P%Num_Nu_Massive = 3
        P%Num_Nu_Massless = 0.04
        P%InitPower%nn = 1
        P%AccuratePolarization = num_cls/=1 
        P%use_optical_depth = .false.
        P%OnlyTransfers = .true.

        if (CMB_Lensing) then
            P%DoLensing = .true.
            P%Max_l = lmax +250
            P%Max_eta_k = P%Max_l*2 
        end if
        
        lensing_includes_tensors = .false.

        P%Scalar_initial_condition = initial_vector
        P%InitialConditionVector = 0
        P%InitialConditionVector(initial_adiabatic) = -1


 end subroutine InitCAMBParams

 subroutine CMB_Initialize(Info)
   Type(ParamSetInfo) Info
   type(CAMBParams)  P 
        compute_tensors = Ini_Read_Logical('compute_tensors',.false.)
        if (num_cls==3 .and. compute_tensors) write (*,*) 'WARNING: computing tensors with num_cls=3 (BB=0)'
        CMB_lensing = Ini_Read_Logical('CMB_lensing',.false.)

        if (Feedback > 0 ) then
          write (*,*) 'Computing tensors:', compute_tensors
          write (*,*) 'Doing CMB lensing:',CMB_lensing
          write(*,'(" lmax           = ",1I4)') lmax       
          if (compute_tensors) write(*,'(" lmax_tensor    = ",1I4)') lmax_tensor
          write(*,'(" Number of C_ls = ",1I4)') num_cls
        end if

        if (CMB_lensing) num_clsS = num_cls   !Also scalar B in this case
     
        call InitCAMBParams(P)
  
        call CAMB_InitCAMBdata(Info%Transfers)
    
        P%WantTensors = compute_tensors
        Info%LastParams%omb = -1 !Make sure we calculate the CMB first time called
        CAMBP = P
        
 end subroutine CMB_Initialize


 subroutine AcceptReject(accpt, CurParams, Trial)
   logical, intent(in) :: accpt
   Type(ParamSetInfo) CurParams, Trial

   if (.not. associated(CurParams%Transfers%ClTransScal%Delta_p_l_k,&
                        Trial%Transfers%ClTransScal%Delta_p_l_k)) then
    !If they point to same memory don't need to free anything
    if (accpt) then
       call CAMB_FreeCAMBdata(CurParams%Transfers)
    else
       call CAMB_FreeCAMBdata(Trial%Transfers)
    end if

   end if

 end subroutine AcceptReject

end module CMB_Cls

